/**
 * Stack Klasse zur Verwaltung eines Stacks mit push, pop, getTop, getElement,
 * empty, getSP, print
 */

public class Stack {

	private int stackArray[];

	private int sp; // stack pointer (pointer to the first "free" cell in stack;

	// it is zero for an empty stack)

	/** Create a 100-elements stack array */
	public Stack() {
		sp = 0;
		stackArray = new int[100];
	}

	/**
	 * Create a maxSize-elements stack array
	 * 
	 * @param maxSize
	 *            Maximale Grsse des Stacks
	 */
	public Stack(int maxSize) {
		sp = 0;
		stackArray = new int[maxSize];
	}

	/**
	 * Element auf den Stack hinzufgen
	 * @param element zu pushendes Element
	 */
	public void push(int element) {
		stackArray[sp++] = element;
	}

	/**
	 * liefert oberstes Stack Element und entfernt es
	 * @return oberstes Stack Element
	 */
	public int pop() {
		return stackArray[--sp];
	}

	/**
	 * liefert oberstes Stack Element ohne es zu entfernen
	 * @return oberstes Stack Element
	 */
	public int getTop() {
		return stackArray[sp - 1];
	}

	/**
	 * liefert das Stack Element an der Position i ohne es zu entfernen
	 * @param i Position
	 * @return Stack Element an der Position <code>i</code>
	 */
	public int getElement(int i) {
		return stackArray[i];
	}

	/**
	 * berprft ob der Stack leer ist
	 * 
	 * @return <code>true</code> falls der Stack leer ist sonst
	 *         <code>false</code>
	 */
	public boolean empty() {
		return sp == 0;
	}

	/**
	 * liefert die aktuelle Stack Position
	 * @return aktuelle Stack Position
	 */
	public int getSP() {
		return sp;
	}

	/**
	 * Inhalt des Stacks auf der Konsole ausgeben
	 */
	public void print() {
		for (int i = 0; i < sp; i++) {
			System.out.print(getElement(i));
			System.out.print(" ");
		}
		System.out.println();
	}
}
